datacache <- new.env(hash=TRUE, parent=emptyenv())

xcelhsrefseq <- function() showQCData("xcelhsrefseq", datacache)
xcelhsrefseq_dbconn <- function() dbconn(datacache)
xcelhsrefseq_dbfile <- function() dbfile(datacache)
xcelhsrefseq_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, file=file, show.indices=show.indices)
xcelhsrefseq_dbInfo <- function() dbInfo(datacache)

xcelhsrefseqORGANISM <- "Homo sapiens"

.onLoad <- function(libname, pkgname)
{
    require("methods", quietly=TRUE)
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "xcelhsrefseq.sqlite", package=pkgname, lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)

    ## Create the OrgDb object
    sPkgname <- sub(".db$","",pkgname)
    txdb <- loadDb(system.file("extdata", paste(sPkgname,
      ".sqlite",sep=""), package=pkgname, lib.loc=libname),
                   packageName=pkgname)    
    dbNewname <- AnnotationDbi:::dbObjectName(pkgname,"ChipDb")
    ns <- asNamespace(pkgname)
    assign(dbNewname, txdb, envir=ns)
    namespaceExport(ns, dbNewname)
        
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs.SchemaChoice("HUMANCHIP_DB", "xcelhsrefseq", "chip xcelhsrefseq", dbconn, datacache)
    mergeToNamespaceAndExport(ann_objs, pkgname)
    packageStartupMessage(AnnotationDbi:::annoStartupMessages("xcelhsrefseq.db"))
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(xcelhsrefseq_dbconn())
}

